unit unData;

interface

type
   tuOsoba = ^tOsoba;
   tOsoba = record
      id, jmeno, prijmeni: string;
      pohlavi: char; // "M" nebo "Z"
      narozeni, // rok narozen
      umrti: integer; // rok mrt
      matka, otec: string; // ID matky a otce
      Dalsi: tuOsoba; // dal osoba v linernm seznamu
      uMatka, uOtec: tuOsoba; // ukazatel na matku a otce
   end;
   tuPoleUzlu = ^tPoleUzlu;
   tUzelStromu = record
      Osoba: tuOsoba;
      Potomci, Partneri: tuPoleUzlu;
      JePlatny: boolean;
   end;
   tPoleUzlu = array of tUzelStromu;

var Osoby: tuOsoba = nil;
    Strom: tPoleUzlu;

function PridejOsobu: tuOsoba;
function NajdiOsobu(const ID: string): tuOsoba;
procedure SestavStrom;



implementation

function PridejOsobu: tuOsoba;
begin
   New(Result);
   Result.id := '';
   Result.jmeno := '';
   Result.prijmeni := '';
   Result.pohlavi := #0;
   Result.narozeni := 0;
   Result.umrti := 0;
   Result.matka := '';
   Result.otec := '';
   Result.Dalsi := Osoby;
   Osoby := Result;
end;


function NajdiOsobu(const ID: string): tuOsoba;
var aOsoba: tuOsoba;
begin
   Result := nil;
   aOsoba := Osoby;
   while aOsoba <> nil do begin
      if aOsoba.id = ID then begin
         Result := aOsoba;
         exit;
      end;
      aOsoba := aOsoba.Dalsi;
   end;
end;


function NajdiUzelOsoby(const Osoba: tuOsoba): pointer;
begin
end;


procedure SpojitRodice(const Matka, Otec: tuOsoba);
var UzelMatky, UzelOtce: ^tUzelStromu;
begin
   UzelMatky := NajdiUzelOsoby(Matka);
   UzelOtce := NajdiUzelOsoby(Otec);
end;


procedure KontrolaStruktury(var Pole: tPoleUzlu; const Hloubka: integer);
var i: integer;
begin
   if Pole = Strom then exit;
   for i := 0 to High(Pole) do begin
      // jestli m otce i matku, pak spojm jeho rodie
      if (Pole[i].Osoba.uMatka <> nil) and (Pole[i].Osoba.uOtec <> nil) then
         SpojitRodice(Pole[i].Osoba.uMatka, Pole[i].Osoba.uOtec);
      KontrolaStruktury(Pole[i].Potomci^, Hloubka + 1);
   end;
end;


procedure NajdiPotomky(const Rodic: tuOsoba; var Potomci: tPoleUzlu; const Hloubka: integer);
var aOsoba: tuOsoba;
    Pridat: boolean;
begin
   SetLength(Potomci, 0);
   aOsoba := Osoby;
   while aOsoba <> nil do begin
      if Rodic = nil then
         Pridat := (aOsoba.uMatka = nil) and (aOsoba.uOtec = nil)
      else
         Pridat := (aOsoba.uMatka = Rodic) or (aOsoba.uOtec = Rodic);
      if Pridat then begin
         SetLength(Potomci, Length(Potomci) + 1);
         Potomci[High(Potomci)].Osoba := aOsoba;
         Potomci[High(Potomci)].JePlatny := true;
         New(Potomci[High(Potomci)].Partneri);
         SetLength(Potomci[High(Potomci)].Partneri^, 0);
         // rekurzivn hledm dal potomky
         New(Potomci[High(Potomci)].Potomci);
         NajdiPotomky(aOsoba, Potomci[High(Potomci)].Potomci^, Hloubka + 1);
      end;
      aOsoba := aOsoba.Dalsi;
   end;
end;


procedure SestavStrom;
var aOsoba: tuOsoba;
begin
   // doplnn linern ukazatelov struktury
   // ukazately na matku a otce
   aOsoba := Osoby;
   while aOsoba <> nil do begin
      aOsoba.uMatka := NajdiOsobu(aOsoba.Matka);
      aOsoba.uOtec := NajdiOsobu(aOsoba.Otec);
      aOsoba := aOsoba.Dalsi;
   end;

   // zanu od shora - tzn., vytvom seznam lid,
   // kte nemaj otce ani matku
   NajdiPotomky(nil, Strom, 0);

   KontrolaStruktury(Strom, 0);
end;


end.
