unit unHlavni;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfoHlavni = class(TForm)
    buNahrat: TButton;
    buUpravovat: TButton;
    OpenD: TOpenDialog;
    buKonec: TButton;
    buZobrazitStrom: TButton;
    procedure buNahratClick(Sender: TObject);
    procedure buUpravovatClick(Sender: TObject);
    procedure buKonecClick(Sender: TObject);
    procedure buZobrazitStromClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  foHlavni: TfoHlavni;

implementation

uses unData, unUpravovat, unZobrazitStrom;

{$R *.DFM}

procedure TfoHlavni.buNahratClick(Sender: TObject);
var f: textfile;
    s: string;
    JmenoElementu, Udaj: string;
    i: integer;
    aOsoba: tuOsoba; // aktuln osoba
begin
   if OpenD.InitialDir = '' then OpenD.InitialDir := ExtractFilePath(ParamStr(0));
   if not OpenD.Execute then exit;
   AssignFile(f, OpenD.FileName);
   reset(f);
   aOsoba := nil;
   Osoby := nil;
   while not eof(f) do begin
      readln(f, s);
      while s <> '' do begin
         i := pos('<', s);
         if i > 0 then begin
            Udaj := Copy(s, 1, i - 1);
            Delete(s, 1, i);
            i := pos('>', s);
            JmenoElementu := AnsiUpperCase(Copy(s, 1, i - 1));
            Delete(s, 1, i);
            if JmenoElementu[length(JmenoElementu)] <> '/' then begin
               if JmenoElementu = 'OSOBA'     then aOsoba := PridejOsobu;
               if JmenoElementu = '/ID'       then aOsoba.id := Udaj;
               if JmenoElementu = '/JMENO'    then aOsoba.jmeno := Udaj;
               if JmenoElementu = '/PRIJMENI' then aOsoba.prijmeni := Udaj;
               if JmenoElementu = '/POHLAVI'  then if Udaj <> '' then aOsoba.pohlavi := Udaj[1];
               if JmenoElementu = '/NAROZENI' then aOsoba.narozeni := StrToInt(Udaj);
               if JmenoElementu = '/UMRTI'    then aOsoba.umrti := StrToInt(Udaj);
               if JmenoElementu = '/MATKA'    then aOsoba.matka := Udaj;
               if JmenoElementu = '/OTEC'     then aOsoba.otec := Udaj;
            end;
         end
         else
            s := '';
      end;
   end;
   closefile(f);
end;

procedure TfoHlavni.buUpravovatClick(Sender: TObject);
begin
   foUpravovat.ObnovSeznam;
   foUpravovat.ShowModal;
end;

procedure TfoHlavni.buKonecClick(Sender: TObject);
begin
   Close;
end;


procedure TfoHlavni.buZobrazitStromClick(Sender: TObject);
var bmp: tBitmap;
    x, y: integer;
   procedure bmpTextOut(const x, y: integer; const s: string);
      var w, h: integer;
      begin
         w := x + bmp.Canvas.TextWidth(s) + 20;
         h := y + bmp.Canvas.TextHeight(s) + 20;
         if w > bmp.Width then bmp.Width := w;
         if h > bmp.Height then bmp.Height := h;
         bmp.Canvas.TextOut(x, y, s);
      end;
   procedure ZobrazPoleUzlu(const Pole: tPoleUzlu; var x: integer; y: integer);
      const OdsazeniX = 200;
            OdsazeniY = 100;
      var i, x1, y1: integer;
      begin
         x1 := x;
         y1 := y;
         y := y + OdsazeniY;
         for i := 0 to High(Pole) do
            if Pole[i].JePlatny then begin
               bmpTextOut(x, y, Pole[i].Osoba.Jmeno + ' ' + Pole[i].Osoba.Prijmeni);
               bmp.Canvas.Pen.Color := clGreen;
               bmp.Canvas.MoveTo(x1 + 20, y1 + 20);
               bmp.Canvas.LineTo(x + 20, y - 5);
               if Length(Pole[i].Potomci^) > 0 then
                  ZobrazPoleUzlu(Pole[i].Potomci^, x, y)
               else
                  x := x + OdsazeniX;
            end;
      end;
begin
   // sestavm ukazatelov strom
   SestavStrom;

   // vykreslm rodokmen
   bmp := tBitmap.Create;
   x := 10;
   y := 10;
   bmpTextOut(x, y, 'Rodokmen');
   ZobrazPoleUzlu(Strom, x, y);
   foZobrazitStrom.Image1.Picture.Assign(bmp);
   bmp.Free;
   foZobrazitStrom.ShowModal;
end;

end.
