unit unUpravovat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TfoUpravovat = class(TForm)
    Label1: TLabel;
    Seznam: TListView;
    paInfo: TPanel;
    buPridat: TButton;
    buSmazat: TButton;
    Label2: TLabel;
    inID: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    inJmeno: TEdit;
    inPrijmeni: TEdit;
    inPohlavi: TEdit;
    inNarozeni: TEdit;
    inUmrti: TEdit;
    inMatka: TEdit;
    inOtec: TEdit;
    procedure inIDChange(Sender: TObject);
    procedure inJmenoChange(Sender: TObject);
    procedure inPrijmeniChange(Sender: TObject);
    procedure inPohlaviChange(Sender: TObject);
    procedure inNarozeniChange(Sender: TObject);
    procedure inUmrtiChange(Sender: TObject);
    procedure inMatkaChange(Sender: TObject);
    procedure inOtecChange(Sender: TObject);
    procedure buPridatClick(Sender: TObject);
    procedure SeznamSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure buSmazatClick(Sender: TObject);
  private
    { Private declarations }
    procedure ZobrazInfo;
  public
    { Public declarations }
    procedure ObnovSeznam;
  end;

var
  foUpravovat: TfoUpravovat;

implementation

uses unData;

{$R *.DFM}

var aOsoba: tuOsoba = nil;

procedure TfoUpravovat.inIDChange(Sender: TObject);
begin
   aOsoba.id := inID.Text;
   Seznam.Selected.Caption := inID.Text;
end;

procedure TfoUpravovat.inJmenoChange(Sender: TObject);
begin
   aOsoba.jmeno := inJmeno.Text;
   Seznam.Selected.SubItems.Strings[1] := inJmeno.Text;
end;

procedure TfoUpravovat.inPrijmeniChange(Sender: TObject);
begin
   aOsoba.prijmeni := inPrijmeni.Text;
   Seznam.Selected.SubItems.Strings[0] := inPrijmeni.Text;
end;

procedure TfoUpravovat.inPohlaviChange(Sender: TObject);
begin
   if inPohlavi.Text = '' then
      aOsoba.pohlavi := #0
   else
      aOsoba.pohlavi := inPohlavi.text[1];
end;

procedure TfoUpravovat.inNarozeniChange(Sender: TObject);
begin
   aOsoba.narozeni := StrToInt(inNarozeni.Text);
end;

procedure TfoUpravovat.inUmrtiChange(Sender: TObject);
begin
   aOsoba.umrti := StrToInt(inUmrti.Text);
end;

procedure TfoUpravovat.inMatkaChange(Sender: TObject);
begin
   aOsoba.matka := inMatka.Text;
end;

procedure TfoUpravovat.inOtecChange(Sender: TObject);
begin
   aOsoba.otec := inOtec.Text;
end;

procedure TfoUpravovat.ZobrazInfo;
begin
   inID.Text := aOsoba.id;
   inJmeno.Text := aOsoba.jmeno;
   inPrijmeni.Text := aOsoba.prijmeni;
   if aOsoba.pohlavi = #0 then
      inPohlavi.Text := ''
   else
      inPohlavi.Text := aOsoba.pohlavi;
   inNarozeni.Text := IntToStr(aOsoba.Narozeni);
   inUmrti.Text := IntToStr(aOsoba.Umrti);
   inMatka.Text := aOsoba.matka;
   inOtec.Text := aOsoba.otec;
end;

procedure TfoUpravovat.buPridatClick(Sender: TObject);
begin
   PridejOsobu;
   ObnovSeznam;
   Seznam.Selected := Seznam.Items.Item[0];
end;

procedure TfoUpravovat.ObnovSeznam;
var aOsoba: tuOsoba;
    LI: tListItem;
begin
   Seznam.Items.Clear;
   aOsoba := Osoby;
   while aOsoba <> nil do begin
      LI := Seznam.Items.Add;
      LI.Caption := aOsoba.id;
      LI.SubItems.Add(aOsoba.Prijmeni);
      LI.SubItems.Add(aOsoba.Jmeno);
      LI.SubItems.Add(IntToStr(Integer(aOsoba)));
      aOsoba := aOsoba.Dalsi;
   end;
   SeznamSelectItem(nil, nil, false);
end;

procedure TfoUpravovat.SeznamSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
   if not Selected then begin
      paInfo.Visible := false;
      buSmazat.Enabled := false;
   end
   else begin
      aOsoba := Pointer(StrToInt(Item.SubItems.Strings[2]));
      ZobrazInfo;
      paInfo.Visible := true;
      buSmazat.Enabled := true;
   end;
end;

procedure TfoUpravovat.buSmazatClick(Sender: TObject);
var Vybrana, Predchozi: tuOsoba;
begin
   Predchozi := nil;
   Vybrana := aOsoba;
   aOsoba := Osoby;

   // najdu pedchoz osobu v seznamu
   while aOsoba <> Vybrana do begin
      Predchozi := aOsoba;
      aOsoba := aOsoba.Dalsi;
   end;

   // smau vybranou osobu
   if Predchozi = nil then
      Osoby := Vybrana.Dalsi // je vybran prvn poloka seznamu
   else
      Predchozi.Dalsi := Vybrana.Dalsi;
   Dispose(Vybrana);
   ObnovSeznam;
end;

end.
